<script lang="ts">
import {
  and,
  type ControlElement,
  formatIs,
  isStringControl,
  type JsonFormsRendererRegistryEntry,
  rankWith,
} from "@jsonforms/core";
import { rendererProps, type RendererProps, useJsonFormsControl } from "@jsonforms/vue";
import { ControlWrapper, DisabledIconFocus, useVuetifyControl } from "@jsonforms/vue-vuetify";
import every from "lodash/every";
import isArray from "lodash/isArray";
import isString from "lodash/isString";
import { defineComponent, ref } from "vue";
import { VHover } from "vuetify/components";

const controlRenderer = defineComponent({
  name: "RorControlRenderer",
  components: {
    ControlWrapper,
    VHover,
  },
  directives: {
    DisabledIconFocus,
  },
  props: {
    ...rendererProps<ControlElement>(),
  },
  setup(props: RendererProps<ControlElement>) {
    const control = useVuetifyControl(
      useJsonFormsControl(props),
      value => value || undefined,
      300,
    );

    const initialValue = control.control.value.data || "";
    const search = ref();
    const listData = ref([]);
    const loading = ref(false);
    const error = ref(null);

    function handle(pathName, valueName) {
      control.handleChange(pathName, valueName);
    }

    if (initialValue !== "") {
      listData.value.push({
        name: initialValue,
        value: initialValue,
      });
    }

    return { ...control, loading, search, listData, handle, error };
  },
  computed: {
    suggestions(): string[] | undefined {
      const suggestions = this.control.uischema.options?.suggestion;

      if (suggestions === undefined || !isArray(suggestions) || !every(suggestions, isString)) {
        return undefined;
      }
      return suggestions;
    },
  },
  watch: {
    async "control.data"(newValue, oldValue) {
      if (newValue !== oldValue && newValue !== "") {
        const apiUrl = `https://api.ror.org/organizations/${newValue}`;
        const regex = /^(\d+)\./;
        const match = this.control.path.match(regex);
        const pos = match ? Number.parseInt(match[1], 10) : null;
        const pathName = pos !== null ? `${pos}.organization.name` : "organization.name";
        const pathUrl = pos !== null ? `${pos}.organization.url` : "organization.url";
        const pathCountry = pos !== null ? `${pos}.organization.address.addressCountry` : "organization.address.addressCountry";
        const pathCity = pos !== null ? `${pos}.organization.address.addressLocality` : "organization.address.addressLocality";

        try {
          this.loading = true;
          const response = await fetch(apiUrl);
          if (!response.ok) throw new Error("Network response was not ok");
          const data = await response.json();
          if (data.name) {
            this.handle(pathName, data.name);
            this.handle(pathUrl, data.links[0]);
            this.handle(pathCountry, data.country.country_name);
            this.handle(pathCity, data.addresses[0].city);
            this.listData.value = [{ name: data.name }];
          } else {
            this.handle(pathName, ""); // Clear organization name if not found
          }
        } catch (error) {
          console.error(error);
        } finally {
          this.loading = false;
        }
      }
    },
  },
});

export default controlRenderer;
export const entry: JsonFormsRendererRegistryEntry = {
  renderer: controlRenderer,
  tester: rankWith(100, and(isStringControl, formatIs("ror"))),
};
</script>

<template>
  <ControlWrapper
    v-bind="controlWrapper"
    :styles="styles"
    :isFocused="isFocused"
    :appliedOptions="appliedOptions"
  >
    <VHover v-slot="{ isHovering }">
      <v-text-field
        :id="`${control.id}-input`"
        :class="styles.control.input"
        :disabled="!control.enabled"
        :autofocus="appliedOptions.focus"
        :placeholder="appliedOptions.placeholder"
        :label="computedLabel"
        :hint="control.description"
        :persistent-hint="persistentHint()"
        :required="control.required"
        :error-messages="control.errors"
        :model-value="control.data"
        :maxlength="
          appliedOptions.restrict ? control.schema.maxLength : undefined
        "
        :counter="
          control.schema.maxLength !== undefined
            ? control.schema.maxLength
            : undefined
        "
        :clearable="isHovering"
        v-bind="vuetifyProps('v-text-field')"
        @update:model-value="onChange"
        @focus="handleFocus"
        @blur="handleBlur"
      />
    </VHover>
  </ControlWrapper>
</template>
